//---------------------------------------------------------------------------
//
// Evj        Model the evolution of DNA binding site recognition
//
// Module:    NewDialog, a Swing dialog for the new simulation parameters.
// Author:    Paul C. Anagnostopoulos
// Created:   1 April 2005
//            The bulk of this code was generated by JFrameBuilder.
//
// This computer program fits the description in the U.S. Copyright Act
// of a "United States Government work." It was written as a part of
// my/our official duties as a Government employee. This means it cannot
// be copyrighted. The program is freely available for use without a
// copyright notice, and there are no restrictions on its use, now or
// subsequently. We retain no rights in the program. Please acknowledge
// the source of this code in any releases you make.
//
//---------------------------------------------------------------------------


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

//                      New Dialog
//                      --- ------


public class NewDialog extends JDialog
{
  private static final int basicWidth = 710,
                           advancedWidth = basicWidth + 210;
  
  private NewDialog thisDialog;     // We need access to this dialog.
  private Param param;              // The parameter object we will populate.

	// Variables declaration
	private JLabel titleLabel;
	private JTextField titleField;
	private JButton okButton;
	private JButton cancelButton;
  private JButton revertButton;
  private JButton standardButton;
	private JButton saveButton;
	private JButton loadButton;
  private JToggleButton advancedButton;
	private JPanel contentPane;
	//-----
	private JLabel populationLabel;
	private JLabel potentialLabel;
	private JLabel sitesLabel;
	private JLabel potential2Label;
	private JLabel population2Label;
	private JLabel sites2Label;
	private JSpinner populationSpinner;
	private JSpinner potentialSpinner;
	private JSpinner sitesSpinner;
	private JPanel basicPanel;
	//-----
	private JLabel weightWidthLabel;
	private JLabel siteWidthLabel;
	private JLabel placementLabel;
	private JLabel weightWidth2Label;
	private JLabel siteWidth2Label;
	private JRadioButton placement1Button;
	private JRadioButton placement2Button;
	private JRadioButton placement3Button;
	private JSpinner weightWidthSpinner;
	private JSpinner siteWidthSpinner;
	private JPanel geneSitePanel;

  private JRadioButton mutation1Button;
  private JRadioButton mutation2Button;
  private JLabel perGenomeLabel;
  private JSpinner perGenomeSpinner;
  private JLabel perBasesLabel;
  private JSpinner perBasesSpinner;
  private JPanel mutationPanel;
  
///  private JLabel mutationsLabel;
///	private JLabel mutations2Label;
///  private JSpinner mutationsSpinner;

  private JLabel tieLabel;
	private JCheckBox selectionCheckBox;
  private JCheckBox perfectionCheckBox;
  private JCheckBox convergenceCheckBox;
  private JCheckBox perfecgenceCheckBox;
	private JRadioButton tie1Button;
	private JRadioButton tie2Button;
	private JRadioButton tie3Button;
  private JPanel selectionPanel;

	private JLabel cyclesLabel;
	private JLabel seedLabel;
	private JLabel seed2Label;
	private JSpinner seedSpinner;
	private JSpinner cyclesSpinner;
	private JPanel otherPanel;

	private ButtonGroup placementGroup;
  private ButtonGroup mutationGroup;
	private ButtonGroup tieGroup;

  private JPanel founderPanel;
  private JCheckBox founderCheckBox;
  private JLabel founderLabel;
  private JSpinner founderSpinner;
  private JLabel founder2Label;
  
  private JPanel mistakePanel;
  private JLabel missedSiteLabel;
  private JLabel spuriousLabel;
  private JLabel withinGeneLabel;
  private JLabel outsideGeneLabel;
  private JSpinner missedSiteSpinner;
  private JSpinner withinGeneSpinner;
  private JSpinner outsideGeneSpinner;

  // End of variables declaration

	public NewDialog (Frame f)
	{
		super(f);
		initializeComponent();
    thisDialog = this;

    param = new Param();
    Evj.copyCurrentParam(param);
    populate(true);
    
    advancedButton.setSelected(!param.isDefaultAdvanced());
    this.setVisible(true);
	}

//                      Initialize Components
//                      ---------- ----------


	private void initializeComponent ()
	{
		titleLabel = new JLabel();
		titleField = new JTextField();
		okButton = new JButton();
		cancelButton = new JButton();
    revertButton = new JButton();
    standardButton = new JButton();
		saveButton = new JButton();
		loadButton = new JButton();
    advancedButton = new JToggleButton();
		contentPane = (JPanel)this.getContentPane();

		populationLabel = new JLabel();
		potentialLabel = new JLabel();
		sitesLabel = new JLabel();
		potential2Label = new JLabel();
		population2Label = new JLabel();
		sites2Label = new JLabel();
		populationSpinner = new JSpinner();
		potentialSpinner = new JSpinner();
		sitesSpinner = new JSpinner();
		basicPanel = new JPanel();

		weightWidthLabel = new JLabel();
		siteWidthLabel = new JLabel();
		placementLabel = new JLabel();
		weightWidth2Label = new JLabel();
		siteWidth2Label = new JLabel();
		placement1Button = new JRadioButton();
		placement2Button = new JRadioButton();
		placement3Button = new JRadioButton();
		weightWidthSpinner = new JSpinner();
		siteWidthSpinner = new JSpinner();
		geneSitePanel = new JPanel();

    mutation1Button = new JRadioButton();
    mutation2Button = new JRadioButton();
    perGenomeLabel = new JLabel();
    perGenomeSpinner = new JSpinner();
    perBasesLabel = new JLabel();
    perBasesSpinner = new JSpinner();
    mutationPanel = new JPanel();

///    mutationsLabel = new JLabel();
///		mutations2Label = new JLabel();
///    mutationsSpinner = new JSpinner();

    tieLabel = new JLabel();
		selectionCheckBox = new JCheckBox();
    perfectionCheckBox = new JCheckBox();
    convergenceCheckBox = new JCheckBox();
    perfecgenceCheckBox = new JCheckBox();
		tie1Button = new JRadioButton();
		tie2Button = new JRadioButton();
		tie3Button = new JRadioButton();
    selectionPanel = new JPanel();

		cyclesLabel = new JLabel();
		seedLabel = new JLabel();
		seed2Label = new JLabel();
		seedSpinner = new JSpinner();
		cyclesSpinner = new JSpinner();
		otherPanel = new JPanel();

		placementGroup = new ButtonGroup();
    mutationGroup = new ButtonGroup();
		tieGroup = new ButtonGroup();

    // Advanced components.
    
    founderPanel = new JPanel();
    founderCheckBox = new JCheckBox();
    founderLabel = new JLabel();
    founderSpinner = new JSpinner();
    founder2Label = new JLabel();

    mistakePanel = new JPanel();
    missedSiteLabel = new JLabel();
    spuriousLabel = new JLabel();
    withinGeneLabel = new JLabel();
    outsideGeneLabel = new JLabel();
    missedSiteSpinner = new JSpinner();
    withinGeneSpinner = new JSpinner();
    outsideGeneSpinner = new JSpinner();

    // Create a new insets object for the buttons.

    Insets insets = okButton.getInsets();
    insets = new Insets(insets.top, 3, insets.bottom, 3);
    
    // titleLabel

		titleLabel.setText("Title");
		titleLabel.setVerticalAlignment(SwingConstants.TOP);
    titleLabel.setToolTipText(Resource.get("ndtip.titleField"));

		// titleField

    titleField.setToolTipText(Resource.get("ndtip.titleField"));
    titleField.setFont(MainFrame.fieldFont);

		// okButton

		okButton.setText("OK");
    okButton.setMargin(insets);
    okButton.setVerticalAlignment(SwingConstants.TOP);
    okButton.setToolTipText(Resource.get("ndtip.okButton"));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed (ActionEvent e)
			{
				okButton_actionPerformed(e);
			}});
      
		// cancelButton

		cancelButton.setText("Cancel");
    cancelButton.setMargin(insets);
    cancelButton.setVerticalAlignment(SwingConstants.TOP);
    cancelButton.setToolTipText(Resource.get("ndtip.cancelButton"));
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				cancelButton_actionPerformed(e);
			}});

    // revertButton

    revertButton.setText("Revert");
    revertButton.setMargin(insets);
    revertButton.setVerticalAlignment(SwingConstants.TOP);
    revertButton.setToolTipText(Resource.get("ndtip.revertButton"));
    revertButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        revertButton_actionPerformed(e);
      }});

    // standardButton

    standardButton.setText("Standard Model");
    standardButton.setMargin(insets);
    standardButton.setVerticalAlignment(SwingConstants.TOP);
    standardButton.setToolTipText(Resource.get("ndtip.standardButton"));
    standardButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        standardButton_actionPerformed(e);
      }});

		// saveButton

		saveButton.setText("Save");
    saveButton.setMargin(insets);
		saveButton.setVerticalAlignment(SwingConstants.TOP);
    saveButton.setToolTipText(Resource.get("ndtip.saveButton"));
		saveButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				saveButton_actionPerformed(e);
			}});

		// loadButton
		//
		loadButton.setText("Load");
    loadButton.setMargin(insets);
		loadButton.setVerticalAlignment(SwingConstants.TOP);
    loadButton.setToolTipText(Resource.get("ndtip.loadButton"));
		loadButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				loadButton_actionPerformed(e);
			}});

    // advancedButton

    advancedButton.setText("Advanced >>");
    advancedButton.setMargin(insets);
    advancedButton.setVerticalAlignment(SwingConstants.TOP);
    advancedButton.setSelected(false);
    advancedButton.setToolTipText(Resource.get("ndtip.advancedButton"));
    advancedButton.addItemListener(new ItemListener() {
      public void itemStateChanged (ItemEvent e)
      {
        advancedButton_itemStateChanged(e);
      }});

    // contentPane

		contentPane.setLayout(null);
		addComponent(contentPane, titleLabel, 15,18,35,18);
		addComponent(contentPane, titleField, 49,15,600,22);
		addComponent(contentPane, okButton, 18,517,70,28);
		addComponent(contentPane, cancelButton, 95,517,70,28);
    addComponent(contentPane, revertButton, 185,517,70,28);
    addComponent(contentPane, standardButton, 262,517,115,28);
		addComponent(contentPane, saveButton, 395,517,70,28);
		addComponent(contentPane, loadButton, 472,517,70,28);
    addComponent(contentPane, advancedButton, 580,517,110,28);
		addComponent(contentPane, basicPanel, 15,53,298,193);
		addComponent(contentPane, geneSitePanel, 15,273,298,226);
		addComponent(contentPane, mutationPanel, 350,54,298,86);
    addComponent(contentPane, selectionPanel, 350,148,298,218);
		addComponent(contentPane, otherPanel, 350,377,298,120);
    addComponent(contentPane, founderPanel, basicWidth-10,57,200,108);
    addComponent(contentPane, mistakePanel, basicWidth-10,182,200,167);

		// populationLabel
		//
		populationLabel.setText("Population");
		populationLabel.setVerticalAlignment(SwingConstants.TOP);
    populationLabel.setToolTipText(Resource.get("ndtip.populationSpinner"));

		// potentialLabel
		//
		potentialLabel.setText("Potential sites");
		potentialLabel.setVerticalAlignment(SwingConstants.TOP);
    potentialLabel.setToolTipText(Resource.get("ndtip.potentialSpinner"));

		// sitesLabel
		//
		sitesLabel.setText("Binding sites");
		sitesLabel.setVerticalAlignment(SwingConstants.TOP);
    sitesLabel.setToolTipText(Resource.get("ndtip.sitesSpinner"));

		// potential2Label
		//
		potential2Label.setText("bases");
		potential2Label.setVerticalAlignment(SwingConstants.TOP);
    potential2Label.setToolTipText(Resource.get("ndtip.potentialSpinner"));

		// population2Label
		//
		population2Label.setText("creatures");
		population2Label.setVerticalAlignment(SwingConstants.TOP);
    population2Label.setToolTipText(Resource.get("ndtip.populationSpinner"));

		// sites2Label
		//
		sites2Label.setText("count");
		sites2Label.setVerticalAlignment(SwingConstants.TOP);
    sites2Label.setToolTipText(Resource.get("ndtip.sitesSpinner"));

		// populationSpinner
		//
    populationSpinner.setToolTipText(Resource.get("ndtip.populationSpinner"));
    populationSpinner.setFont(MainFrame.fieldFont);

		// potentialSpinner
		//
    potentialSpinner.setToolTipText(Resource.get("ndtip.potentialSpinner"));
    potentialSpinner.setFont(MainFrame.fieldFont);

		// sitesSpinner
		//
    sitesSpinner.setToolTipText(Resource.get("ndtip.sitesSpinner"));
    sitesSpinner.setFont(MainFrame.fieldFont);

		// basicPanel
		//
		basicPanel.setLayout(null);
		basicPanel.setBorder(new TitledBorder("Basic parameters"));
		addComponent(basicPanel, populationLabel, 10,39,83,18);
		addComponent(basicPanel, potentialLabel, 13,88,90,18);
		addComponent(basicPanel, sitesLabel, 12,142,90,18);
		addComponent(basicPanel, potential2Label, 195,86,60,18);
		addComponent(basicPanel, population2Label, 192,43,60,18);
		addComponent(basicPanel, sites2Label, 193,144,60,18);
		addComponent(basicPanel, populationSpinner, 108,37,70,25);
		addComponent(basicPanel, potentialSpinner, 108,83,70,24);
		addComponent(basicPanel, sitesSpinner, 106,139,70,24);

		// weightWidthLabel
		//
		weightWidthLabel.setText("Weight width");
		weightWidthLabel.setVerticalAlignment(SwingConstants.TOP);
    weightWidthLabel.setToolTipText(Resource.get("ndtip.weightWidthSpinner"));

		// siteWidthLabel
		//
		siteWidthLabel.setText("Site width");
		siteWidthLabel.setVerticalAlignment(SwingConstants.TOP);
    siteWidthLabel.setToolTipText(Resource.get("ndtip.siteWidthSpinner"));

		// placementLabel
		//
		placementLabel.setText("Placement");
		placementLabel.setVerticalAlignment(SwingConstants.TOP);
    placementLabel.setToolTipText(Resource.get("ndtip.placementLabel"));

		// weightWidth2Label
		//
		weightWidth2Label.setText("bases");
		weightWidth2Label.setVerticalAlignment(SwingConstants.TOP);
    weightWidth2Label.setToolTipText(Resource.get("ndtip.weightWidthSpinner"));

		// siteWidth2Label
		//
		siteWidth2Label.setText("bases");
		siteWidth2Label.setVerticalAlignment(SwingConstants.TOP);
    siteWidth2Label.setToolTipText(Resource.get("ndtip.siteWidthSpinner"));

		// placement1Button

		placement1Button.setText("regular array");
		placement1Button.setVerticalAlignment(SwingConstants.TOP);
		placement1Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(placement1Button, Param.PLACE_ARRAYED);
    placement1Button.setToolTipText(Resource.get("ndtip.placement1Button"));

		// placement2Button

		placement2Button.setText("random, nonoverlapping");
		placement2Button.setVerticalAlignment(SwingConstants.TOP);
		placement2Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(placement2Button, Param.PLACE_RANDOM);
    placement2Button.setToolTipText(Resource.get("ndtip.placement2Button"));

		// placement3Button
		//
		placement3Button.setText("random, overlapping");
		placement3Button.setVerticalAlignment(SwingConstants.TOP);
		placement3Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(placement3Button, Param.PLACE_RANDOM_OVERLAP);
    placement3Button.setToolTipText(Resource.get("ndtip.placement3Button"));

		// weightWidthSpinner
		//
    weightWidthSpinner.setToolTipText(Resource.get("ndtip.weightWidthSpinner"));
    weightWidthSpinner.setFont(MainFrame.fieldFont);

		// siteWidthSpinner
		//
    siteWidthSpinner.setToolTipText(Resource.get("ndtip.siteWidthSpinner"));
    siteWidthSpinner.setFont(MainFrame.fieldFont);

		// geneSitePanel
		//
		geneSitePanel.setLayout(null);
		geneSitePanel.setBorder(new TitledBorder("Gene and site parameters"));
		addComponent(geneSitePanel, weightWidthLabel, 17,42,85,18);
		addComponent(geneSitePanel, siteWidthLabel, 18,90,85,18);
		addComponent(geneSitePanel, placementLabel, 17,138,81,18);
		addComponent(geneSitePanel, weightWidth2Label, 186,42,60,18);
		addComponent(geneSitePanel, siteWidth2Label, 188,91,60,18);
		addComponent(geneSitePanel, placement1Button, 99,134,180,24);
		addComponent(geneSitePanel, placement2Button, 99,162,180,24);
		addComponent(geneSitePanel, placement3Button, 99,190,180,24);
		addComponent(geneSitePanel, weightWidthSpinner, 100,37,70,26);
		addComponent(geneSitePanel, siteWidthSpinner, 101,87,70,25);

    // mutation1Button

    mutation1Button.setText("");
    mutation1Button.setVerticalAlignment(SwingConstants.TOP);
    mutation1Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(mutation1Button, Param.MUTATION_PER_GENOME);
    mutation1Button.setToolTipText(Resource.get("ndtip.mutation1Button"));

    // mutation2Button

    mutation2Button.setText(" 1 mutation per");
    mutation2Button.setVerticalAlignment(SwingConstants.TOP);
    mutation2Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(mutation2Button, Param.MUTATION_PER_BASES);
    mutation2Button.setToolTipText(Resource.get("ndtip.mutation2Button"));

    // perGenomeLabel

		perGenomeLabel.setText("mutation(s) per genome");
		perGenomeLabel.setVerticalAlignment(SwingConstants.TOP);
    perGenomeLabel.setToolTipText(Resource.get("ndtip.perGenomeSpinner"));

    // perGenomeSpinner

    perGenomeSpinner.setToolTipText(Resource.get("ndtip.perGenomeSpinner"));
    perGenomeSpinner.setFont(MainFrame.fieldFont);

		// perBasesLabel

		perBasesLabel.setText("bases");
		perBasesLabel.setVerticalAlignment(SwingConstants.TOP);
    perBasesLabel.setToolTipText(Resource.get("ndtip.perBasesSpinner"));

    // perBasesSpinner

    perBasesSpinner.setToolTipText(Resource.get("ndtip.perBasesSpinner"));
    perBasesSpinner.setFont(MainFrame.fieldFont);

    // mutationPanel

    mutationPanel.setLayout(null);
    mutationPanel.setBorder(new TitledBorder("Mutation parameters"));
    addComponent(mutationPanel, mutation1Button, 16,28,25,24);
    addComponent(mutationPanel, mutation2Button, 16,56,125,24);
    addComponent(mutationPanel, perGenomeSpinner, 45,28,50,22);
    addComponent(mutationPanel, perGenomeLabel, 105,28,150,18);
    addComponent(mutationPanel, perBasesSpinner, 141,56,80,22);
    addComponent(mutationPanel, perBasesLabel, 228,56,69,18);

    // tieLabel

		tieLabel.setText("Tie score ");
		tieLabel.setVerticalAlignment(SwingConstants.TOP);
    tieLabel.setToolTipText(Resource.get("ndtip.tieLabel"));

		// selectionCheckBox

		selectionCheckBox.setText("Perform selection");
		selectionCheckBox.setVerticalAlignment(SwingConstants.TOP);
		selectionCheckBox.setVerticalTextPosition(SwingConstants.TOP);
		selectionCheckBox.setSelected(true);
    selectionCheckBox.setToolTipText(Resource.get("ndtip.selectionCheckBox"));

    // perfectionCheckBox

    perfectionCheckBox.setText("Pause on 0 mistakes");
    perfectionCheckBox.setVerticalAlignment(SwingConstants.TOP);
    perfectionCheckBox.setVerticalTextPosition(SwingConstants.TOP);
    perfectionCheckBox.setSelected(false);
    perfectionCheckBox.setToolTipText(Resource.get("ndtip.perfectionCheckBox"));

    // convergenceCheckBox

    convergenceCheckBox.setText("Pause on Rsequence \u2265 Rfrequency");
    convergenceCheckBox.setVerticalAlignment(SwingConstants.TOP);
    convergenceCheckBox.setVerticalTextPosition(SwingConstants.TOP);
    convergenceCheckBox.setSelected(false);
    convergenceCheckBox.setToolTipText(Resource.get("ndtip.convergenceCheckBox"));

    // perfecgenceCheckBox
    
    perfecgenceCheckBox.setText("Pause on both conditions");
    perfecgenceCheckBox.setVerticalAlignment(SwingConstants.TOP);
    perfecgenceCheckBox.setVerticalTextPosition(SwingConstants.TOP);
    perfecgenceCheckBox.setSelected(false);
    perfecgenceCheckBox.setToolTipText(Resource.get("ndtip.perfecgenceCheckBox"));

		// tie1Button

		tie1Button.setText("Both survive");
		tie1Button.setVerticalAlignment(SwingConstants.TOP);
		tie1Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(tie1Button, Param.TIE_BOTH);
    tie1Button.setToolTipText(Resource.get("ndtip.tie1Button"));

		// tie2Button
		//
		tie2Button.setText("First survives");
		tie2Button.setVerticalAlignment(SwingConstants.TOP);
		tie2Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(tie2Button, Param.TIE_FIRST);
    tie2Button.setToolTipText(Resource.get("ndtip.tie2Button"));

		// tie3Button
		//
		tie3Button.setText("Random one survives");
		tie3Button.setVerticalAlignment(SwingConstants.TOP);
		tie3Button.setVerticalTextPosition(SwingConstants.TOP);
    setButtonCode(tie3Button, Param.TIE_RANDOM);
    tie3Button.setToolTipText(Resource.get("ndtip.tie3Button"));

    // selectionPanel

    selectionPanel.setLayout(null);
    selectionPanel.setBorder(new TitledBorder("Selection parameters"));
    addComponent(selectionPanel, selectionCheckBox, 21,31,140,24);
    addComponent(selectionPanel, perfectionCheckBox, 21,58,200,24);
    addComponent(selectionPanel, convergenceCheckBox, 21,86,250,24);
    addComponent(selectionPanel, perfecgenceCheckBox, 21,113,250,24);
    addComponent(selectionPanel, tieLabel, 21,144,60,18);
    addComponent(selectionPanel, tie1Button, 91,144,165,24);
    addComponent(selectionPanel, tie2Button, 91,167,165,24);
    addComponent(selectionPanel, tie3Button, 91,189,165,24);

		// cyclesLabel
		//
		cyclesLabel.setText("Cycles to run");
		cyclesLabel.setVerticalAlignment(SwingConstants.TOP);
    cyclesLabel.setToolTipText(Resource.get("ndtip.cyclesSpinner"));

		// seedLabel
		//
		seedLabel.setText("Random seed");
		seedLabel.setVerticalAlignment(SwingConstants.TOP);
    seedLabel.setToolTipText(Resource.get("ndtip.seedSpinner"));

		// seed2Label
		//
		seed2Label.setText("integer");
		seed2Label.setVerticalAlignment(SwingConstants.TOP);
    seed2Label.setToolTipText(Resource.get("ndtip.seedSpinner"));

		// seedSpinner
		//
    seedSpinner.setToolTipText(Resource.get("ndtip.seedSpinner"));
    seedSpinner.setFont(MainFrame.fieldFont);

		// cyclesSpinner

    cyclesSpinner.setToolTipText(Resource.get("ndtip.cyclesSpinner"));
    cyclesSpinner.setFont(MainFrame.fieldFont);

		// otherPanel

		otherPanel.setLayout(null);
		otherPanel.setBorder(new TitledBorder("Other parameters"));
		addComponent(otherPanel, cyclesLabel, 16,40,92,18);
    addComponent(otherPanel, cyclesSpinner, 114,38,90,22);
		addComponent(otherPanel, seedLabel, 18,85,93,18);
		addComponent(otherPanel, seed2Label, 227,85,60,18);
		addComponent(otherPanel, seedSpinner, 115,85,90,22);

		// placementGroup

		placementGroup.add(placement1Button);
		placementGroup.add(placement2Button);
		placementGroup.add(placement3Button);

    // mutationGroup

    mutationGroup.add(mutation1Button);
    mutationGroup.add(mutation2Button);

    // tieGroup

		tieGroup.add(tie1Button);
		tieGroup.add(tie2Button);
		tieGroup.add(tie3Button);

    // founderCheckBox

    founderCheckBox.setText("Use founder model");
    founderCheckBox.setVerticalAlignment(SwingConstants.TOP);
    founderCheckBox.setVerticalTextPosition(SwingConstants.TOP);
    founderCheckBox.setSelected(false);
    founderCheckBox.setToolTipText(Resource.get("ndtip.founderCheckBox"));

    // founderLabel

    founderLabel.setText("Founders");
    founderLabel.setVerticalAlignment(SwingConstants.TOP);
    founderLabel.setToolTipText(Resource.get("ndtip.founderSpinner"));

    //founderSpinner
    
    founderSpinner.setToolTipText(Resource.get("ndtip.founderSpinner"));
    founderSpinner.setFont(MainFrame.fieldFont);

    // founder2Label

    founder2Label.setText("creatures");
    founder2Label.setVerticalAlignment(SwingConstants.TOP);
    founder2Label.setToolTipText(Resource.get("ndtip.founderSpinner"));

    // founderPanel

    founderPanel.setLayout(null);
    founderPanel.setBorder(new TitledBorder("Founder model"));
    addComponent(founderPanel, founderCheckBox, 12,28,148,24);
    addComponent(founderPanel, founderLabel, 14,63,60,18);
    addComponent(founderPanel, founderSpinner, 75,60,40,22);
    addComponent(founderPanel, founder2Label, 127,63,60,18);

    // missedSiteLabel

    missedSiteLabel.setText("Missed site");
    missedSiteLabel.setVerticalAlignment(SwingConstants.TOP);
    missedSiteLabel.setToolTipText(Resource.get("ndtip.missedSiteSpinner"));

    // spuriousLabel

    spuriousLabel.setText("Spurious binding");
    spuriousLabel.setVerticalAlignment(SwingConstants.TOP);
    spuriousLabel.setToolTipText(Resource.get("ndtip.spuriousLabel"));

    // withinGeneLabel

    withinGeneLabel.setText("within gene");
    withinGeneLabel.setVerticalAlignment(SwingConstants.TOP);
    withinGeneLabel.setToolTipText(Resource.get("ndtip.withinGeneSpinner"));

    // outsideGeneLabel

    outsideGeneLabel.setText("outside gene");
    outsideGeneLabel.setVerticalAlignment(SwingConstants.TOP);
    outsideGeneLabel.setToolTipText(Resource.get("ndtip.outsideGeneSpinner"));

    // missedSiteSpinner

    missedSiteSpinner.setToolTipText(Resource.get("ndtip.missedSiteSpinner"));
    missedSiteSpinner.setFont(MainFrame.fieldFont);
    missedSiteSpinner.setToolTipText(Resource.get("ndtip.missedSiteSpinner"));

    // withinGeneSpinner

    withinGeneSpinner.setToolTipText(Resource.get("ndtip.withinGeneSpinner"));
    withinGeneSpinner.setFont(MainFrame.fieldFont);
    withinGeneSpinner.setToolTipText(Resource.get("ndtip.withinGeneSpinner"));

    // outsideGeneSpinner

    outsideGeneSpinner.setToolTipText(Resource.get("ndtip.outsideGeneSpinner"));
    outsideGeneSpinner.setFont(MainFrame.fieldFont);
    outsideGeneSpinner.setToolTipText(Resource.get("ndtip.outsideGeneSpinner"));

    // mistakePanel

    mistakePanel.setLayout(null);
    mistakePanel.setBorder(new TitledBorder("Mistake points"));
    addComponent(mistakePanel, missedSiteLabel, 14,36,106,18);
    addComponent(mistakePanel, spuriousLabel, 14,73,108,18);
    addComponent(mistakePanel, withinGeneLabel, 22,95,97,18);
    addComponent(mistakePanel, outsideGeneLabel, 22,125,93,18);
    addComponent(mistakePanel, missedSiteSpinner, 130,32,50,22);
    addComponent(mistakePanel, withinGeneSpinner, 130,91,50,22);
    addComponent(mistakePanel, outsideGeneSpinner, 130,123,50,22);

    // NewDialog

		this.setTitle("New Model Parameters");
		this.setLocation(new Point(132, 114));
    this.setSize(basicWidth, 600);
		this.setModal(true);
		this.setResizable(true);
    this.setBackground(MainFrame.backgroundColor);
    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	}

	/** Add Component Without a Layout Manager (Absolute Positioning) */
  
	private void addComponent(Container container, Component c,
                            int x, int y, int width, int height)
	{
		c.setBounds(x, y, width, height);
		container.add(c);
	}

//                      Populate Components
//                      -------- ----------


  // This method populates the dialog components with the values from
  // the parameter object.
  
  private void populate (boolean set)
  {
    param.populateTextField(Param.title, titleField, set);
    param.populateSpinner(Param.population, populationSpinner, set);
    param.populateSpinner(Param.potentialSites, potentialSpinner, set);
    param.populateSpinner(Param.sites, sitesSpinner, set);
    param.populateSpinner(Param.weightWidth, weightWidthSpinner, set);
    param.populateButtonGroup(Param.placement, placementGroup, set);
    param.populateSpinner(Param.siteWidth, siteWidthSpinner, set);
    param.populateButtonGroup(Param.mutationMethod, mutationGroup, set);
    param.populateSpinner(Param.mutationsPerGenome, perGenomeSpinner, set);
    param.populateSpinner(Param.mutationsPerBases, perBasesSpinner, set);
    param.populateCheckBox(Param.selection, selectionCheckBox, set);
    param.populateCheckBox(Param.perfection, perfectionCheckBox, set);
    param.populateCheckBox(Param.convergence, convergenceCheckBox, set);
    param.populateCheckBox(Param.perfecgence, perfecgenceCheckBox, set);
    param.populateButtonGroup(Param.tie, tieGroup, set);
    param.populateSpinner(Param.cycles, cyclesSpinner, set);
    param.populateSpinner(Param.seed, seedSpinner, set);
    param.populateCheckBox(Param.useFounder, founderCheckBox, set);
    param.populateSpinner(Param.founders, founderSpinner, set);
    param.populateSpinner(Param.missedSite, missedSiteSpinner, set);
    param.populateSpinner(Param.spuriousGene, withinGeneSpinner, set);
    param.populateSpinner(Param.spuriousNongene, outsideGeneSpinner, set);
  }

//                      Event Handlers
//                      ----- --------


  // When the OK button is pressed, copy the component values into the
  // parameter object. Then validate them. If they are valid, save the
  // values so they can be reset and start up a new simulation. If they
  // are invalid, display the message.
  
  private void okButton_actionPerformed(ActionEvent e)
	{
    String msg;
    
    populate(false);
    if ((msg = param.validate()) == null) {
      param.save_for_restore();
      Evj.newSimulation(param);
      dispose();
    } else
      Msg.error(this, msg);
	}

	private void cancelButton_actionPerformed(ActionEvent e)
	{
    dispose();
	}

  // When the Revert button is pressed, reset the component values to
  // the parameter values.
  
  private void revertButton_actionPerformed(ActionEvent e)
  {
    populate(true);
  }

  private void standardButton_actionPerformed(ActionEvent e)
  {
    param = new Param();
    populate(true);
  }

  private void saveButton_actionPerformed(ActionEvent e)
	{
    String name = parameterSetName();

    if (name != null) {
      populate(false);
      param.saveParameters(name);
    }
	}

	private void loadButton_actionPerformed(ActionEvent e)
	{
    String name = parameterSetName();

    if (name != null) {
      if (param.loadParameters(name))
        populate(true);
      else
        Msg.warning(this, "The parameter set '" + name + "' does not exist.");
    }
	}

  private void advancedButton_itemStateChanged (ItemEvent e)
  {
    boolean set = e.getStateChange() == ItemEvent.SELECTED;

    if (set) {
      advancedButton.setText("<<");
      thisDialog.setSize(advancedWidth, 600);
    } else {
      advancedButton.setText("Advanced >>");
      thisDialog.setSize(basicWidth, 600);
    }
    thisDialog.validate();
  }

//                      Utilities
//                      ---------


  String parameterSetName ()
  {
    String name;

    for (;;) {
      name = JOptionPane.showInputDialog(
                    this,
                    Resource.get("pstip.text"),
                    "Parameter Set Name",
                    JOptionPane.QUESTION_MESSAGE);
      if (name == null || name.length() > 0) return name;
    }
  }
  
  void setButtonCode (JRadioButton button, char code)
  {
    button.getModel().setActionCommand(String.valueOf(code));
  }

}
